"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var SrcdsLogType = require("./SrcdsLog");
var Globals = require("../globals");
var ConnectionActions;
(function (ConnectionActions) {
    ConnectionActions[ConnectionActions["Connected"] = 1] = "Connected";
    ConnectionActions[ConnectionActions["Disconnected"] = 2] = "Disconnected";
    ConnectionActions[ConnectionActions["EnteredGame"] = 3] = "EnteredGame";
    ConnectionActions[ConnectionActions["Unknown"] = 4] = "Unknown";
})(ConnectionActions = exports.ConnectionActions || (exports.ConnectionActions = {}));
var ConnectionType = (function (_super) {
    __extends(ConnectionType, _super);
    function ConnectionType(time, data) {
        var _this = _super.call(this, time) || this;
        _this.Player = new Globals.Player(data[1]);
        switch (data[2]) {
            case 'connected':
                _this.Address = data[3];
                _this.Action = ConnectionActions.Connected;
                break;
            case 'disconnected':
                _this.Reason = data[3];
                _this.Action = ConnectionActions.Disconnected;
                break;
            case 'entered':
                _this.Action = ConnectionActions.EnteredGame;
                break;
        }
        _this.Type = "Connection";
        return _this;
    }
    ConnectionType.Identifier = [
        {
            regex: new RegExp(/^/.source + Globals.SteamIdRegex.source + / (connected), address "(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})?"$/.source)
        },
        {
            regex: new RegExp(/^/.source + Globals.SteamIdRegex.source + / (disconnected) \(reason "(.+)"\)$/.source)
        },
        {
            regex: new RegExp(/^/.source + Globals.SteamIdRegex.source + / (entered) the game$/.source)
        }
    ];
    return ConnectionType;
}(SrcdsLogType.SrcdsLog));
exports.ConnectionType = ConnectionType;
//# sourceMappingURL=ConnectionType.js.map