"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var SrcdsLogType = require("./SrcdsLog");
var ServerEvents;
(function (ServerEvents) {
    ServerEvents[ServerEvents["MapLoading"] = 1] = "MapLoading";
    ServerEvents[ServerEvents["MapStarted"] = 2] = "MapStarted";
    ServerEvents[ServerEvents["LogFileOpened"] = 3] = "LogFileOpened";
    ServerEvents[ServerEvents["LogFileClosed"] = 4] = "LogFileClosed";
    ServerEvents[ServerEvents["ServerMessage"] = 5] = "ServerMessage";
    ServerEvents[ServerEvents["Unknown"] = 6] = "Unknown";
})(ServerEvents = exports.ServerEvents || (exports.ServerEvents = {}));
var ServerEventType = (function (_super) {
    __extends(ServerEventType, _super);
    function ServerEventType(time, data, extraArg) {
        var _this = _super.call(this, time) || this;
        _this.Type = "ServerEvent";
        switch (extraArg) {
            case 'loadingmap':
                _this.EventType = data[1] == 'Loading' ? ServerEvents.MapLoading : ServerEvents.MapStarted;
                _this.Data = {
                    Map: data[2],
                    CRC: data[3]
                };
                break;
            case 'logopen':
                _this.EventType = ServerEvents.LogFileOpened;
                _this.Data = {
                    file: data[1],
                    game: data[2],
                    version: data[3]
                };
                break;
            case 'logclosed':
                _this.EventType = ServerEvents.LogFileClosed;
                break;
            case 'server_message':
                _this.EventType = ServerEvents.ServerMessage;
                _this.Data = data[1];
                break;
            default: throw "invalid extraArg supplied to ServerEventType - " + extraArg;
        }
        return _this;
    }
    ServerEventType.Identifier = [{
            regex: /^(Loading|Started) map "(.+)"(?: \(CRC "([-\d]+)"\))?$/,
            extraArg: 'loadingmap'
        }, {
            regex: /^Log file started \(file "(\S+)"\) \(game "(\S+)"\) \(version "(\S+)"\)$/,
            extraArg: 'logopen'
        }, {
            regex: /^Log file closed$/,
            extraArg: 'logclosed'
        }, {
            regex: /^server_message: "(.+)"$/,
            extraArg: 'server_message'
        },
    ];
    return ServerEventType;
}(SrcdsLogType.SrcdsLog));
exports.ServerEventType = ServerEventType;
//# sourceMappingURL=ServerEventType.js.map