"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var SrcdsLogType = require("./SrcdsLog");
var Globals = require("../globals");
var TeamTriggerType;
(function (TeamTriggerType) {
    TeamTriggerType[TeamTriggerType["SFUI_Notice_Terrorists_Win"] = 1] = "SFUI_Notice_Terrorists_Win";
    TeamTriggerType[TeamTriggerType["SFUI_Notice_CTs_Win"] = 2] = "SFUI_Notice_CTs_Win";
    TeamTriggerType[TeamTriggerType["SFUI_Notice_Target_Bombed"] = 3] = "SFUI_Notice_Target_Bombed";
    TeamTriggerType[TeamTriggerType["SFUI_Notice_Target_Saved"] = 4] = "SFUI_Notice_Target_Saved";
    TeamTriggerType[TeamTriggerType["SFUI_Notice_Bomb_Defused"] = 5] = "SFUI_Notice_Bomb_Defused";
    TeamTriggerType[TeamTriggerType["Unknown"] = -1] = "Unknown";
})(TeamTriggerType = exports.TeamTriggerType || (exports.TeamTriggerType = {}));
var TeamTriggeredType = (function (_super) {
    __extends(TeamTriggeredType, _super);
    function TeamTriggeredType(time, data) {
        var _this = _super.call(this, time) || this;
        _this.Type = "TeamTriggered";
        var eventType;
        _this.Team = Globals.getTeam(data[1]);
        eventType = data[2];
        _this.TerroristScore = parseInt(data[4]);
        _this.CounterTerroristScore = parseInt(data[3]);
        switch (eventType) {
            case 'SFUI_Notice_Terrorists_Win':
                _this.EventType = TeamTriggerType.SFUI_Notice_Terrorists_Win;
                break;
            case 'SFUI_Notice_CTs_Win':
                _this.EventType = TeamTriggerType.SFUI_Notice_CTs_Win;
                break;
            case 'SFUI_Notice_Target_Bombed':
                _this.EventType = TeamTriggerType.SFUI_Notice_Target_Bombed;
                break;
            case 'SFUI_Notice_Target_Saved':
                _this.EventType = TeamTriggerType.SFUI_Notice_Target_Saved;
                break;
            case 'SFUI_Notice_Bomb_Defused':
                _this.EventType = TeamTriggerType.SFUI_Notice_Bomb_Defused;
                break;
            default:
                _this.EventType = TeamTriggerType.Unknown;
                console.error("Unknown team trigger event type: ", eventType);
                break;
        }
        return _this;
    }
    TeamTriggeredType.Identifier = {
        regex: new RegExp("^Team " + Globals.TeamRegex.source + / triggered "(\S+)" \(CT "(\d+)"\) \(T "(\d+)"\)$/.source)
    };
    return TeamTriggeredType;
}(SrcdsLogType.SrcdsLog));
exports.TeamTriggeredType = TeamTriggeredType;
//# sourceMappingURL=TeamTriggeredType.js.map