"use strict";
exports.__esModule = true;
var moment = require("moment");
var AssistType = require("./Types/AssistType");
var AttackedType = require("./Types/AttackedType");
var ConnectionType = require("./Types/ConnectionType");
var KilledType = require("./Types/KilledType");
var PlayerNameType = require("./Types/PlayerNameType");
var PlayerTriggeredType = require("./Types/PlayerTriggeredType");
var PurchasedType = require("./Types/PurchasedType");
var RconType = require("./Types/RconType");
var SayType = require("./Types/SayType");
var ScoredType = require("./Types/ScoredType");
var ServerCvarType = require("./Types/ServerCvarType");
var ServerEventType = require("./Types/ServerEventType");
var SpawnedType = require("./Types/SpawnedType");
var SrcdsLogType = require("./Types/SrcdsLog");
var SuicideType = require("./Types/SuicideType");
var SwitchedType = require("./Types/SwitchedType");
var TeamNameType = require("./Types/TeamNameType");
var TeamTriggeredType = require("./Types/TeamTriggeredType");
var ThrewType = require("./Types/ThrewType");
var ValidatedType = require("./Types/ValidatedType");
var WarmodType = require("./Types/WarmodType");
var lengthOfDate = "06/09/2016 - 10:07:28: ".length;
var ConnectionType_1 = require("./Types/ConnectionType");
exports.ConnectionActions = ConnectionType_1.ConnectionActions;
var PlayerTriggeredType_1 = require("./Types/PlayerTriggeredType");
exports.PlayerTriggerType = PlayerTriggeredType_1.PlayerTriggerType;
var TeamTriggeredType_1 = require("./Types/TeamTriggeredType");
exports.TeamTriggerType = TeamTriggeredType_1.TeamTriggerType;
var globals_1 = require("./globals");
exports.Team = globals_1.Team;
var ServerEventType_1 = require("./Types/ServerEventType");
exports.ServerEvents = ServerEventType_1.ServerEvents;
var SrcdsLogParser = (function () {
    function SrcdsLogParser() {
    }
    SrcdsLogParser.prototype.parseLine = function (line) {
        var date = this.getDate(line.slice(0, lengthOfDate - 2));
        return this.getInstanceOf(date, line.slice(lengthOfDate));
    };
    SrcdsLogParser.prototype.getDate = function (dateTokens) {
        var m = moment(dateTokens, "MM/DD/YYYY - HH:mm:ss", true);
        if (m.isValid() == false) {
            console.error("Invalid date: ", dateTokens);
        }
        return m;
    };
    SrcdsLogParser.prototype.getInstanceOf = function (time, rawMessage) {
        var returnValue;
        constructors.forEach(function (v) {
            var regexResult = v.regex.regex.exec(rawMessage);
            if (regexResult) {
                returnValue = new v.cons(time, regexResult, v.regex.extraArg);
            }
        });
        if (returnValue)
            return returnValue;
        else
            return new SrcdsLogType.UnknownType(time, rawMessage);
    };
    return SrcdsLogParser;
}());
exports.SrcdsLogParser = SrcdsLogParser;
var constructors = [];
var types = [
    AssistType.AssistType,
    AttackedType.AttackedType,
    ConnectionType.ConnectionType,
    KilledType.KilledType,
    PlayerNameType.PlayerNameType,
    PlayerTriggeredType.PlayerTriggeredType,
    PurchasedType.PurchasedType,
    RconType.RconType,
    SayType.SayType,
    ScoredType.ScoredType,
    ServerCvarType.ServerCvarType,
    ServerEventType.ServerEventType,
    SpawnedType.SpawnedType,
    SuicideType.SuicideType,
    SwitchedType.SwitchedType,
    TeamNameType.TeamNameType,
    TeamTriggeredType.TeamTriggeredType,
    ThrewType.ThrewType,
    ValidatedType.ValidatedType,
    WarmodType.WarmodType,
];
types.forEach(function (t) {
    if (Array.isArray(t.Identifier)) {
        t.Identifier.forEach(function (i) {
            constructors.push({ regex: i, cons: t });
        });
    }
    else {
        constructors.push({
            regex: t.Identifier,
            cons: t
        });
    }
});
//# sourceMappingURL=index.js.map